//Mandelbrot Set - Single Precision
/*
 *  Copyright (C) 2012 Khaldoon Ghanem
 *  See the file license.txt for copying permission.
 */

#version 120
uniform mat3 windowToComplex;

void main()
{
    vec3 complexCood = windowToComplex *
                       vec3(gl_FragCoord.x, gl_FragCoord.y, 1);

    vec2 z = vec2(0, 0);
    int iter;
    int maxIter = 100;
    for (iter = 0; iter < maxIter; iter++)
    {
        z = vec2(complexCood.x + (z.x * z.x - z.y * z.y),
                         complexCood.y + (2.0 * z.x * z.y));
        //z = temp;
        if (z.x * z.x + z.y * z.y > 4.0)
            break;
    }
    if (iter == maxIter)
        gl_FragColor = vec4(0, 0, 0, 1.0);
    else
    {
        float alpha = float(iter) / float(maxIter);
        vec4 yellow = vec4(1.0, 1.0, 0.3, 1.0);
        vec4 blue = vec4(0.4, 0.2, 1.0, 1.0);
        gl_FragColor = mix(blue, yellow, alpha);
    }
}
